diff --git a/hw/xquartz/X11Controller.m b/hw/xquartz/X11Controller.m
index e21aed0d3..c75493c42 100644
--- a/hw/xquartz/X11Controller.m
+++ b/hw/xquartz/X11Controller.m
@@ -693,115 +686,179 @@ - (IBAction) toggle_fullscreen:sender
     DarwinSendDDXEvent(kXquartzToggleFullscreen, 0);
 }
 
+- (void) set_can_quit:(OSX_BOOL)state
+{
+    can_quit = state;
+}
+
 - (IBAction)prefs_changed:sender
 {
     if (!sender)
         return;
 
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-
-    if (sender == self.fake_buttons) {
-        darwinFakeButtons = !!self.fake_buttons.state;
-        [defaults setBool:darwinFakeButtons forKey:XQuartzPrefKeyFakeButtons];
-    } else if (sender == self.enable_keyequivs) {
-        XQuartzEnableKeyEquivalents = !!self.enable_keyequivs.state;
-        [defaults setBool:XQuartzEnableKeyEquivalents forKey:XQuartzPrefKeyKeyEquivs];
-    } else if (sender == self.sync_keymap) {
-        darwinSyncKeymap = !!self.sync_keymap.state;
-        [defaults setBool:darwinSyncKeymap forKey:XQuartzPrefKeySyncKeymap];
-    } else if (sender == self.enable_fullscreen_menu) {
-        XQuartzFullscreenMenu = !!self.enable_fullscreen_menu.state;
-        [defaults setBool:XQuartzFullscreenMenu forKey:XQuartzPrefKeyFullscreenMenu];
-    } else if (sender == self.option_sends_alt) {
+    if (sender == fake_buttons) {
+        darwinFakeButtons = [fake_buttons intValue];
+        [NSApp prefs_set_boolean:@PREFS_FAKEBUTTONS value:darwinFakeButtons];
+    }
+    else if (sender == enable_keyequivs) {
+        XQuartzEnableKeyEquivalents = [enable_keyequivs intValue];
+        [NSApp prefs_set_boolean:@PREFS_KEYEQUIVS value:
+         XQuartzEnableKeyEquivalents];
+    }
+    else if (sender == sync_keymap) {
+        darwinSyncKeymap = [sync_keymap intValue];
+        [NSApp prefs_set_boolean:@PREFS_SYNC_KEYMAP value:darwinSyncKeymap];
+    }
+    else if (sender == enable_fullscreen_menu) {
+        XQuartzFullscreenMenu = [enable_fullscreen_menu intValue];
+        [NSApp prefs_set_boolean:@PREFS_FULLSCREEN_MENU value:
+         XQuartzFullscreenMenu];
+    }
+    else if (sender == option_sends_alt) {
         BOOL prev_opt_sends_alt = XQuartzOptionSendsAlt;
 
-        XQuartzOptionSendsAlt = !!self.option_sends_alt.state;
-        [defaults setBool:XQuartzOptionSendsAlt forKey:XQuartzPrefKeyOptionSendsAlt];
+        XQuartzOptionSendsAlt = [option_sends_alt intValue];
+        [NSApp prefs_set_boolean:@PREFS_OPTION_SENDS_ALT value:
+         XQuartzOptionSendsAlt];
 
         if (prev_opt_sends_alt != XQuartzOptionSendsAlt)
             QuartsResyncKeymap(TRUE);
-    } else if (sender == self.click_through) {
-        [defaults setBool:!!self.click_through.state forKey:XQuartzPrefKeyClickThrough];
-    } else if (sender == self.focus_follows_mouse) {
-        [defaults setBool:!!self.focus_follows_mouse.state forKey:XQuartzPrefKeyFocusFollowsMouse];
-    } else if (sender == self.focus_on_new_window) {
-        [defaults setBool:!!self.focus_on_new_window.state forKey:XQuartzPrefKeyFocusOnNewWindow];
-    } else if (sender == self.enable_auth) {
-        [defaults setBool:!self.enable_auth.state forKey:XQuartzPrefKeyNoAuth];
-    } else if (sender == self.enable_tcp) {
-        [defaults setBool:!self.enable_tcp.state forKey:XQuartzPrefKeyNoTCP];
-    } else if (sender == self.depth) {
-        [defaults setInteger:self.depth.selectedTag forKey:XQuartzPrefKeyDepth];
-    } else if (sender == self.sync_pasteboard) {
-        BOOL pbproxy_active = self.sync_pasteboard.intValue;
-        [defaults setBool:pbproxy_active forKey:XQuartzPrefKeySyncPasteboard];
-
-        [self.sync_pasteboard_to_clipboard setEnabled:pbproxy_active];
-        [self.sync_pasteboard_to_primary setEnabled:pbproxy_active];
-        [self.sync_clipboard_to_pasteboard setEnabled:pbproxy_active];
-        [self.sync_primary_immediately setEnabled:pbproxy_active];
+    }
+    else if (sender == click_through) {
+        [NSApp prefs_set_boolean:@PREFS_CLICK_THROUGH value:[click_through
+                                                             intValue]];
+    }
+    else if (sender == focus_follows_mouse) {
+        [NSApp prefs_set_boolean:@PREFS_FFM value:[focus_follows_mouse
+                                                   intValue]];
+    }
+    else if (sender == focus_on_new_window) {
+        [NSApp prefs_set_boolean:@PREFS_FOCUS_ON_NEW_WINDOW value:[
+             focus_on_new_window intValue]];
+    }
+    else if (sender == enable_auth) {
+        [NSApp prefs_set_boolean:@PREFS_NO_AUTH value:![enable_auth intValue]
+        ];
+    }
+    else if (sender == enable_tcp) {
+        [NSApp prefs_set_boolean:@PREFS_NO_TCP value:![enable_tcp intValue]];
+    }
+    else if (sender == depth) {
+        [NSApp prefs_set_integer:@PREFS_DEPTH value:[depth selectedTag]];
+    }
+    else if (sender == sync_pasteboard) {
+        BOOL pbproxy_active = [sync_pasteboard intValue];
+        [NSApp prefs_set_boolean:@PREFS_SYNC_PB value:pbproxy_active];
+
+        [sync_pasteboard_to_clipboard setEnabled:pbproxy_active];
+        [sync_pasteboard_to_primary setEnabled:pbproxy_active];
+        [sync_clipboard_to_pasteboard setEnabled:pbproxy_active];
+        [sync_primary_immediately setEnabled:pbproxy_active];
 
         // setEnabled doesn't do this...
-        [self.sync_text1 setTextColor:pbproxy_active ? NSColor.controlTextColor : NSColor.disabledControlTextColor];
-        [self.sync_text2 setTextColor:pbproxy_active ? NSColor.controlTextColor : NSColor.disabledControlTextColor];
-    } else if (sender == self.sync_pasteboard_to_clipboard) {
-        [defaults setBool:!!self.sync_pasteboard_to_clipboard.state forKey:XQuartzPrefKeySyncPasteboardToClipboard];
-    } else if (sender == self.sync_pasteboard_to_primary) {
-        [defaults setBool:!!self.sync_pasteboard_to_primary.state forKey:XQuartzPrefKeySyncPasteboardToPrimary];
-    } else if (sender == self.sync_clipboard_to_pasteboard) {
-        [defaults setBool:!!self.sync_clipboard_to_pasteboard.state forKey:XQuartzPrefKeySyncClipboardToPasteBoard];
-    } else if (sender == self.sync_primary_immediately) {
-        [defaults setBool:!!self.sync_primary_immediately.state forKey:XQuartzPrefKeySyncPrimaryOnSelect];
-    } else if (sender == self.scroll_in_device_direction) {
-        XQuartzScrollInDeviceDirection = !!self.scroll_in_device_direction.state;
-        [defaults setBool:XQuartzScrollInDeviceDirection forKey:XQuartzPrefKeyScrollInDeviceDirection];
+        [sync_text1 setTextColor:pbproxy_active ?[NSColor controlTextColor] :
+         [NSColor disabledControlTextColor]];
+        [sync_text2 setTextColor:pbproxy_active ?[NSColor controlTextColor] :
+         [NSColor disabledControlTextColor]];
+    }
+    else if (sender == sync_pasteboard_to_clipboard) {
+        [NSApp prefs_set_boolean:@PREFS_SYNC_PB_TO_CLIPBOARD value:[
+             sync_pasteboard_to_clipboard intValue]];
+    }
+    else if (sender == sync_pasteboard_to_primary) {
+        [NSApp prefs_set_boolean:@PREFS_SYNC_PB_TO_PRIMARY value:[
+             sync_pasteboard_to_primary intValue]];
+    }
+    else if (sender == sync_clipboard_to_pasteboard) {
+        [NSApp prefs_set_boolean:@PREFS_SYNC_CLIPBOARD_TO_PB value:[
+             sync_clipboard_to_pasteboard intValue]];
+    }
+    else if (sender == sync_primary_immediately) {
+        [NSApp prefs_set_boolean:@PREFS_SYNC_PRIMARY_ON_SELECT value:[
+             sync_primary_immediately intValue]];
+    }
+    else if (sender == scroll_in_device_direction) {
+        XQuartzScrollInDeviceDirection =
+            [scroll_in_device_direction intValue];
+        [NSApp prefs_set_boolean:@PREFS_SCROLL_IN_DEV_DIRECTION value:
+         XQuartzScrollInDeviceDirection];
     }
 
+    [NSApp prefs_synchronize];
+
     DarwinSendDDXEvent(kXquartzReloadPreferences, 0);
 }
 
 - (IBAction) prefs_show:sender
 {
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-
-    BOOL pbproxy_active = [defaults boolForKey:XQuartzPrefKeySyncPasteboard];
-
-    [self.scroll_in_device_direction setIntValue:XQuartzScrollInDeviceDirection];
-
-    [self.fake_buttons setIntValue:darwinFakeButtons];
-    [self.enable_keyequivs setIntValue:XQuartzEnableKeyEquivalents];
-    [self.sync_keymap setIntValue:darwinSyncKeymap];
-    [self.option_sends_alt setIntValue:XQuartzOptionSendsAlt];
-    [self.click_through setIntValue:[defaults boolForKey:XQuartzPrefKeyClickThrough]];
-    [self.focus_follows_mouse setIntValue:[defaults boolForKey:XQuartzPrefKeyFocusFollowsMouse]];
-    [self.focus_on_new_window setIntValue:[defaults boolForKey:XQuartzPrefKeyFocusOnNewWindow]];
+    BOOL pbproxy_active =
+        [NSApp prefs_get_boolean:@PREFS_SYNC_PB default:YES];
 
-    [self.enable_auth setIntValue:![defaults boolForKey:XQuartzPrefKeyNoAuth]];
-    [self.enable_tcp setIntValue:![defaults boolForKey:XQuartzPrefKeyNoTCP]];
-
-    [self.depth selectItemAtIndex:[self.depth indexOfItemWithTag:[defaults integerForKey:XQuartzPrefKeyDepth]]];
-
-    [self.sync_pasteboard setIntValue:pbproxy_active];
-    [self.sync_pasteboard_to_clipboard setIntValue:[defaults boolForKey:XQuartzPrefKeySyncPasteboardToClipboard]];
-    [self.sync_pasteboard_to_primary setIntValue:[defaults boolForKey:XQuartzPrefKeySyncPasteboardToPrimary]];
-    [self.sync_clipboard_to_pasteboard setIntValue:[defaults boolForKey:XQuartzPrefKeySyncClipboardToPasteBoard]];
-    [self.sync_primary_immediately setIntValue:[defaults boolForKey:XQuartzPrefKeySyncPrimaryOnSelect]];
+    // Remove preferences from the GUI which are not supported
+    // TODO: Change 1117 to NSAppKitVersionNumber10_7 when it is defined
+    if (scroll_in_device_direction && NSAppKitVersionNumber < 1117) {
+        [scroll_in_device_direction removeFromSuperview];
+        scroll_in_device_direction = nil;
+    }
+    else {
+        [scroll_in_device_direction setIntValue:
+         XQuartzScrollInDeviceDirection];
+    }
 
-    [self.sync_pasteboard_to_clipboard setEnabled:pbproxy_active];
-    [self.sync_pasteboard_to_primary setEnabled:pbproxy_active];
-    [self.sync_clipboard_to_pasteboard setEnabled:pbproxy_active];
-    [self.sync_primary_immediately setEnabled:pbproxy_active];
+    [fake_buttons setIntValue:darwinFakeButtons];
+    [enable_keyequivs setIntValue:XQuartzEnableKeyEquivalents];
+    [sync_keymap setIntValue:darwinSyncKeymap];
+    [option_sends_alt setIntValue:XQuartzOptionSendsAlt];
+    [click_through setIntValue:[NSApp prefs_get_boolean:@PREFS_CLICK_THROUGH
+                                default:NO]];
+    [focus_follows_mouse setIntValue:[NSApp prefs_get_boolean:@PREFS_FFM
+                                      default:NO]];
+    [focus_on_new_window setIntValue:[NSApp prefs_get_boolean:
+                                      @PREFS_FOCUS_ON_NEW_WINDOW default:YES]
+    ];
+
+    [enable_auth setIntValue:![NSApp prefs_get_boolean:@PREFS_NO_AUTH default
+                               :NO]];
+    [enable_tcp setIntValue:![NSApp prefs_get_boolean:@PREFS_NO_TCP default:
+                              NO]];
+
+    [depth selectItemAtIndex:[depth indexOfItemWithTag:[NSApp
+                                                        prefs_get_integer:
+                                                        @PREFS_DEPTH default:
+                                                        -1]]];
+
+    [sync_pasteboard setIntValue:pbproxy_active];
+    [sync_pasteboard_to_clipboard setIntValue:[NSApp prefs_get_boolean:
+                                               @PREFS_SYNC_PB_TO_CLIPBOARD
+                                               default:YES]];
+    [sync_pasteboard_to_primary setIntValue:[NSApp prefs_get_boolean:
+                                             @PREFS_SYNC_PB_TO_PRIMARY
+                                             default:YES]];
+    [sync_clipboard_to_pasteboard setIntValue:[NSApp prefs_get_boolean:
+                                               @PREFS_SYNC_CLIPBOARD_TO_PB
+                                               default:YES]];
+    [sync_primary_immediately setIntValue:[NSApp prefs_get_boolean:
+                                           @PREFS_SYNC_PRIMARY_ON_SELECT
+                                           default:NO]];
+
+    [sync_pasteboard_to_clipboard setEnabled:pbproxy_active];
+    [sync_pasteboard_to_primary setEnabled:pbproxy_active];
+    [sync_clipboard_to_pasteboard setEnabled:pbproxy_active];
+    [sync_primary_immediately setEnabled:pbproxy_active];
 
     // setEnabled doesn't do this...
-    [self.sync_text1 setTextColor:pbproxy_active ? NSColor.controlTextColor : NSColor.disabledControlTextColor];
-    [self.sync_text2 setTextColor:pbproxy_active ? NSColor.controlTextColor : NSColor.disabledControlTextColor];
+    [sync_text1 setTextColor:pbproxy_active ?[NSColor controlTextColor] : [
+         NSColor disabledControlTextColor]];
+    [sync_text2 setTextColor:pbproxy_active ?[NSColor controlTextColor] : [
+         NSColor disabledControlTextColor]];
 
-    [self.enable_fullscreen setIntValue:!XQuartzRootlessDefault];
-    [self.enable_fullscreen_menu setIntValue:XQuartzFullscreenMenu];
-    [self.enable_fullscreen_menu setEnabled:!XQuartzRootlessDefault];
-    [self.enable_fullscreen_menu_text setTextColor:XQuartzRootlessDefault ? NSColor.disabledControlTextColor : NSColor.controlTextColor];
+    [enable_fullscreen setIntValue:!XQuartzRootlessDefault];
+    [enable_fullscreen_menu setIntValue:XQuartzFullscreenMenu];
+    [enable_fullscreen_menu setEnabled:!XQuartzRootlessDefault];
+    [enable_fullscreen_menu_text setTextColor:XQuartzRootlessDefault ?[
+         NSColor disabledControlTextColor] : [NSColor controlTextColor]];
 
-    [self.prefs_panel makeKeyAndOrderFront:sender];
+    [prefs_panel makeKeyAndOrderFront:sender];
 }
 
 - (IBAction) quit:sender
@@ -811,18 +868,23 @@ - (IBAction) quit:sender
 
 - (IBAction) x11_help:sender
 {
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1060
+    AHLookupAnchor((CFStringRef)NSLocalizedString(@"Mac Help",
+                                                  no comment),
+                   CFSTR("mchlp2276"));
+#else
     AHLookupAnchor(CFSTR("com.apple.machelp"), CFSTR("mchlp2276"));
+#endif
 }
 
 - (OSX_BOOL) validateMenuItem:(NSMenuItem *)item
 {
     NSMenu *menu = [item menu];
-    NSMenu * const dock_menu = self.dock_menu;
 
-    if (item == self.toggle_fullscreen_item)
+    if (item == toggle_fullscreen_item)
         return !XQuartzIsRootless;
     else if (menu == [X11App windowsMenu] || menu == dock_menu
-             || (menu == [self.x11_about_item menu] && [item tag] == 42))
+             || (menu == [x11_about_item menu] && [item tag] == 42))
         return (AppleWMSelectedEvents() & AppleWMControllerNotifyMask) != 0;
     else
         return TRUE;
@@ -850,11 +912,9 @@ - (NSApplicationTerminateReply) applicationShouldTerminate:sender
     NSString *msg;
     NSString *title;
 
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-
-    if (self.can_quit || [defaults boolForKey:XQuartzPrefKeyNoQuitAlert]) {
+    if (can_quit ||
+        [X11App prefs_get_boolean:@PREFS_NO_QUIT_ALERT default:NO])
         return NSTerminateNow;
-    }
 
     /* Make sure we're frontmost. */
     [NSApp activateIgnoringOtherApps:YES];
@@ -876,6 +936,8 @@ - (NSApplicationTerminateReply) applicationShouldTerminate:sender
 
 - (void) applicationWillTerminate:(NSNotification *)aNotification _X_NORETURN
 {
+    [X11App prefs_synchronize];
+
     /* shutdown the X server, it will exit () for us. */
     DarwinSendDDXEvent(kXquartzQuit, 0);
 
@@ -889,26 +951,26 @@ - (void) server_ready
 {
     x_list *node;
 
-    self.finished_launching = YES;
+    finished_launching = YES;
 
-    for (node = self.pending_apps; node != NULL; node = node->next) {
+    for (node = pending_apps; node != NULL; node = node->next) {
         NSString *filename = node->data;
         [self launch_client:filename];
         [filename release];
     }
 
-    x_list_free(self.pending_apps);
-    self.pending_apps = NULL;
+    x_list_free(pending_apps);
+    pending_apps = NULL;
 }
 
 - (OSX_BOOL) application:(NSApplication *)app openFile:(NSString *)filename
 {
     const char *name = [filename UTF8String];
 
-    if (self.finished_launching)
+    if (finished_launching)
         [self launch_client:filename];
     else if (name[0] != ':')            /* ignore display names */
-        self.pending_apps = x_list_prepend(self.pending_apps, [filename retain]);
+        pending_apps = x_list_prepend(pending_apps, [filename retain]);
 
     /* FIXME: report failures. */
     return YES;
diff --git a/hw/xquartz/applewm.c b/hw/xquartz/applewm.c
index e743a861e..cc91c9608 100644
--- a/hw/xquartz/applewm.c
+++ b/hw/xquartz/applewm.c
@@ -34,7 +34,7 @@
 #include <dix-config.h>
 #endif
 
-#include "quartz.h"
+#include "quartzCommon.h"
 
 #include "misc.h"
 #include "dixstruct.h"
diff --git a/hw/xquartz/applewmExt.h b/hw/xquartz/applewmExt.h
index 9a8b8d639..14c77214a 100644
--- a/hw/xquartz/applewmExt.h
+++ b/hw/xquartz/applewmExt.h
@@ -35,6 +35,12 @@
 #include "window.h"
 #include <Xplugin.h>
 
+#if XPLUGIN_VERSION < 4
+typedef int xp_frame_attr;
+typedef int xp_frame_class;
+typedef int xp_frame_rect;
+#endif
+
 typedef int (*DisableUpdateProc)(void);
 typedef int (*EnableUpdateProc)(void);
 typedef int (*SetWindowLevelProc)(WindowPtr pWin, int level);
diff --git a/hw/xquartz/bundle/Info.plist.cpp b/hw/xquartz/bundle/Info.plist.cpp
index f576f7eb5..6314c7181 100644
--- a/hw/xquartz/bundle/Info.plist.cpp
+++ b/hw/xquartz/bundle/Info.plist.cpp
@@ -28,45 +28,20 @@
 		<true/>
 	<key>NSSupportsAutomaticGraphicsSwitching</key>
 		<true/>
-
-	<!-- Add generic usage descriptions for TCC
-	     https://github.com/XQuartz/XQuartz/issues/245
-	  -->
-	<key>NSAppleEventsUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants to use AppleScript.</string>
-	<key>NSCalendarsUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your calendar data.</string>
-	<key>NSCameraUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your camera.</string>
-	<key>NSContactsUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your contacts.</string>
-	<key>NSLocationAlwaysUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your location information, even when not in use.</string>
-	<key>NSLocationUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your location information.</string>
-	<key>NSLocationWhenInUseUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your location information when in use.</string>
-	<key>NSMicrophoneUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your microphone.</string>
-	<key>NSRemindersUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants access to your reminders.</string>
-	<key>NSSystemAdministrationUsageDescription</key>
-	<string>A process launched by APPLE_APPLICATION_NAME wants admin privileges.</string>
-
 #ifdef XQUARTZ_SPARKLE
 	<key>SUEnableAutomaticChecks</key>
 		<true/>
-	<key>SUPublicEDKey</key>
-		<string>XQUARTZ_SPARKLE_PUBLIC_EDKEY</string>
+	<key>SUPublicDSAKeyFile</key>
+		<string>sparkle.pem</string>
         <key>SUFeedURL</key>
                 <string>XQUARTZ_SPARKLE_FEED_URL</string>
 #endif
 	<key>LSApplicationCategoryType</key>
 		<string>public.app-category.utilities</string>
 	<key>NSHumanReadableCopyright</key>
-		<string>© 2003-2023 Apple Inc.
+		<string>© 2003-2021 Apple Inc.
 © 2003 XFree86 Project, Inc.
-© 2003-2023 X.org Foundation, Inc.
+© 2003-2021 X.org Foundation, Inc.
 </string>
 	<key>NSMainNibFile</key>
 		<string>main</string>
